#include <malloc.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Allocate an array of NMEMB elements each SIZE bytes long.
   The entire array is initialized to zeros.  */
void * calloc ( unsigned int nmemb, unsigned int size)
{
  register __ptr_t result = malloc (nmemb * size);

  if (result != NULL)
     memset (result, 0, nmemb * size);

  return result;
}

void * calloc0 ( unsigned int nmemb, unsigned int size)
{
  register __ptr_t result = malloc0 (nmemb * size);

  if (result != NULL)
    memset (result, 0, nmemb * size);

  return result;
}

void * calloc1 ( unsigned int nmemb, unsigned int size)
{
  register __ptr_t result = malloc1 (nmemb * size);

  if (result != NULL)
    memset (result, 0, nmemb * size);

  return result;
}

void * calloc2 ( unsigned int nmemb, unsigned int size)
{
  register __ptr_t result = malloc2 (nmemb * size);

  if (result != NULL)
    memset (result, 0, nmemb * size);

  return result;
}

void * calloc3 ( unsigned int nmemb, unsigned int size)
{
  register __ptr_t result = malloc3 (nmemb * size);

  if (result != NULL)
    memset (result, 0, nmemb * size);

  return result;
}

#ifdef __cplusplus
}   // extern "C"
#endif
