//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// strtok.c,
//
//----------------------------------------------------------------

#include <stdlib.h>
#include <string.h>

static char *olds = NULL;

#ifdef __cplusplus
extern "C"
#endif
char * strtok ( register char *s,register const char *delim)
{
  char *token;

  if (s == NULL)
    {
      if (olds == NULL)
	{
	  errno = EINVAL;
	  return NULL;
	}
      else
	s = olds;
    }

  /* search the leading delimiter */
  s += strspn(s, delim);
  if (*s == '\0')
    {
      olds = NULL;
      return NULL;
    }

  /* search the end of the token */
  token = s;
  s = strpbrk(token, delim);
  if (s == NULL)
    /* the token terminates the string */
    olds = NULL;
  else
    {
      /* terminate the token, olds will point at the next char */
      *s = '\0';
      olds = s + 1;
    }
  return token;
}
